<?php
class ControllerExtensionPaymentPaynet extends Controller {
  private $error = array();

  public function index() {
    $this->load->language('extension/payment/paynet');

    $this->document->setTitle($this->language->get('heading_title'));

    $this->load->model('setting/setting');

    if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
      $this->model_setting_setting->editSetting('payment_paynet', $this->request->post);

      $this->session->data['success'] = $this->language->get('text_success');

      $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
    }

    $data['heading_title'] = $this->language->get('heading_title');
    $data['text_edit'] = $this->language->get('text_edit');

    $data['text_live_mode'] = $this->language->get('text_live_mode');
    $data['text_test_mode'] = $this->language->get('text_test_mode');
    $data['text_enabled'] = $this->language->get('text_enabled');
    $data['text_disabled'] = $this->language->get('text_disabled');
    $data['text_all_zones'] = $this->language->get('text_all_zones');

    $data['entry_email'] = $this->language->get('entry_email');
    $data['entry_order_status'] = $this->language->get('entry_order_status');
    $data['entry_order_status_completed_text'] = $this->language->get('entry_order_status_completed_text');
    $data['entry_order_status_pending'] = $this->language->get('entry_order_status_pending');
    $data['entry_order_status_canceled'] = $this->language->get('entry_order_status_canceled');
    $data['entry_order_status_failed'] = $this->language->get('entry_order_status_failed');
    $data['entry_order_status_failed_text'] = $this->language->get('entry_order_status_failed_text');
    $data['entry_order_status_processing'] = $this->language->get('entry_order_status_processing');
    $data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
    $data['entry_status'] = $this->language->get('entry_status');
    $data['entry_sort_order'] = $this->language->get('entry_sort_order');
    $data['entry_merchant_code'] = $this->language->get('entry_merchant_code');
    $data['entry_merchant_code_help'] = $this->language->get('entry_merchant_code_help');
    $data['entry_secret_key'] = $this->language->get('entry_secret_key');
    $data['entry_secret_key_help'] = $this->language->get('entry_secret_key_help');
    $data['entry_api_login'] = $this->language->get('entry_api_login');
    $data['entry_api_login_help'] = $this->language->get('entry_api_login_help');
    $data['entry_api_password'] = $this->language->get('entry_api_password');
    $data['entry_api_password_help'] = $this->language->get('entry_api_password_help');
    $data['entry_payment_method'] = $this->language->get('entry_payment_method');
    $data['entry_test_mode'] = $this->language->get('entry_test_mode');
    $data['entry_test_mode_help'] = $this->language->get('entry_test_mode_help');
    $data['button_save'] = $this->language->get('button_save');
    $data['button_cancel'] = $this->language->get('button_cancel');
    $data['tab_general'] = $this->language->get('tab_general');

    if (isset($this->error['warning'])) {
      $data['error_warning'] = $this->error['warning'];
    } else {
      $data['error_warning'] = '';
    }

    if (isset($this->error['merchant_code'])) {
      $data['error_merchant_code'] = $this->error['merchant_code'];
    } else {
      $data['error_merchant_code'] = '';
    }

    if (isset($this->error['secret_key'])) {
      $data['error_secret_key'] = $this->error['secret_key'];
    } else {
      $data['error_secret_key'] = '';
    }

    if (isset($this->error['api_login'])) {
      $data['error_api_login'] = $this->error['api_login'];
    } else {
      $data['error_api_login'] = '';
    }

    if (isset($this->error['api_password'])) {
      $data['error_api_password'] = $this->error['api_password'];
    } else {
      $data['error_api_password'] = '';
    }

    $data['breadcrumbs'] = array();

    $data['breadcrumbs'][] = array(
      'text'      => $this->language->get('text_home'),
      'href'      =>  $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true),
      'separator' => false
    );

    $data['breadcrumbs'][] = array(
      'text' => $this->language->get('text_extension'),
      'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
    );

    $data['breadcrumbs'][] = array(
      'text'      => $this->language->get('heading_title'),
      'href'      => $this->url->link('extension/payment/paynet', 'user_token=' . $this->session->data['user_token'], true),
      'separator' => ' :: '
    );

    $data['action'] = $this->url->link('extension/payment/paynet', 'user_token=' . $this->session->data['user_token'], true);

    $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token']  . '&type=payment', true);


    if (isset($this->request->post['payment_paynet_merchant_code'])) {
      $data['payment_paynet_merchant_code'] = $this->request->post['payment_paynet_merchant_code'];
    } else {
      $data['payment_paynet_merchant_code'] = $this->config->get('payment_paynet_merchant_code');
    }

    if (isset($this->request->post['payment_paynet_secret_key'])) {
      $data['payment_paynet_secret_key'] = $this->request->post['payment_paynet_secret_key'];
    } else {
      $data['payment_paynet_secret_key'] = $this->config->get('payment_paynet_secret_key');
    }

    if (isset($this->request->post['payment_paynet_api_login'])) {
      $data['payment_paynet_api_login'] = $this->request->post['payment_paynet_api_login'];
    } else {
      $data['payment_paynet_api_login'] = $this->config->get('payment_paynet_api_login');
    }

		if (isset($this->request->post['payment_paynet_api_password'])) {
			$data['payment_paynet_api_password'] = $this->request->post['payment_paynet_api_password'];
		} else {
			$data['payment_paynet_api_password'] = $this->config->get('payment_paynet_api_password');
		}

		if (isset($this->request->post['payment_paynet_payment_method'])) {
			$data['payment_paynet_payment_method'] = $this->request->post['payment_paynet_payment_method'];
		} else {
			$data['payment_paynet_payment_method'] = $this->config->get('payment_paynet_payment_method');
		}

    if (isset($this->request->post['payment_paynet_completed_status_id'])) {
      $data['payment_paynet_completed_status_id'] = $this->request->post['payment_paynet_completed_status_id'];
    } else {
      $data['payment_paynet_completed_status_id'] = $this->config->get('payment_paynet_completed_status_id');
    }

    if (isset($this->request->post['payment_paynet_failed_status_id'])) {
      $data['payment_paynet_failed_status_id'] = $this->request->post['payment_paynet_failed_status_id'];
    } else {
      $data['payment_paynet_failed_status_id'] = $this->config->get('payment_paynet_failed_status_id');
    }

    $this->load->model('localisation/order_status');

    $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

    if (isset($this->request->post['payment_paynet_status'])) {
      $data['payment_paynet_status'] = $this->request->post['payment_paynet_status'];
    } else {
      $data['payment_paynet_status'] = $this->config->get('payment_paynet_status');
    }

    if (isset($this->request->post['payment_paynet_test_mode'])) {
      $data['payment_paynet_test_mode'] = $this->request->post['payment_paynet_test_mode'];
    } else {
      $data['payment_paynet_test_mode'] = $this->config->get('payment_paynet_test_mode');
    }

    $this->load->model('localisation/geo_zone');

    $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

    if (isset($this->request->post['payment_paynet_sort_order'])) {
      $data['payment_paynet_sort_order'] = $this->request->post['payment_paynet_sort_order'];
    } else {
      $data['payment_paynet_sort_order'] = $this->config->get('payment_paynet_sort_order');
    }

    $data['user_token'] = $this->session->data['user_token'];

    $data['header'] = $this->load->controller('common/header');
    $data['column_left'] = $this->load->controller('common/column_left');
    $data['footer'] = $this->load->controller('common/footer');

    $this->response->setOutput($this->load->view('extension/payment/paynet', $data));
  }

  private function validate() {
    if (!$this->user->hasPermission('modify', 'extension/payment/paynet')) {
      $this->error['warning'] = $this->language->get('error_permission');
    }

    if (!$this->request->post['payment_paynet_merchant_code']) {
      $this->error['merchant_code'] = $this->language->get('error_merchant_code');
    }

    if (!$this->request->post['payment_paynet_secret_key']) {
      $this->error['secret_key'] = $this->language->get('error_secret_key');
    }

    if (!$this->request->post['payment_paynet_api_login']) {
      $this->error['api_login'] = $this->language->get('error_api_login');
    }

    if (!$this->request->post['payment_paynet_api_password']) {
      $this->error['api_password'] = $this->language->get('error_api_password');
    }

		if (!isset($this->request->post['payment_paynet_payment_method'])) {
			$this->error['payment_method'] = $this->language->get('error_payment_method');
		} else {
      $sum = 0;
      foreach($this->request->post['payment_paynet_payment_method'] as $k => $v) {
        $sum = $sum + $this->request->post['payment_paynet_payment_method'][$k];
      }
      if ($sum == 0)
  			$this->error['payment_method'] = $this->language->get('error_payment_method');
    }

    return !$this->error;
  }
}
